# Uses of Class
org.apache.sling.feature.Feature

Packages that use Feature
Package
Description
org.apache.sling.feature
org.apache.sling.feature.builder
org.apache.sling.feature.io.archive
org.apache.sling.feature.io.json
org.apache.sling.feature.osgi

## Uses of Feature in org.apache.sling.feature

Methods in org.apache.sling.feature that return Feature
Modifier and Type
Method
Description
`Feature`
Feature.`copy()`
Create a copy of the feature
`Feature`
Feature.`copy(ArtifactId id)`
Create a copy of the feature with a different id For contained items like bundles, artifacts and configurations a copy is created as well.
Methods in org.apache.sling.feature with parameters of type Feature
Modifier and Type
Method
Description
`int`
Feature.`compareTo(Feature o)`
`static ExecutionEnvironmentExtension`
ExecutionEnvironmentExtension.`getExecutionEnvironmentExtension(Feature feature)`
Get the execution environment from the feature - if it exists.

## Uses of Feature in org.apache.sling.feature.builder

Methods in org.apache.sling.feature.builder that return Feature
Modifier and Type
Method
Description
`static Feature`
FeatureBuilder.`assemble(ArtifactId featureId, BuilderContext context, Feature... features)`
Assemble a feature based on the provided features.
`static Feature`
FeatureBuilder.`assemble(Feature feature, BuilderContext context)`
Assemble the full feature by processing its prototype.
`static Feature[]`
FeatureBuilder.`deduplicate(BuilderContext context, Feature... features)`
Remove duplicate and prototype features.
`Feature`
FeatureProvider.`provide(ArtifactId id)`
Provide the feature with the given id.
`static Feature[]`
FeatureBuilder.`resolve(BuilderContext context, String... featureIds)`
Resolve a set of features based on their ids.
Methods in org.apache.sling.feature.builder with parameters of type Feature
Modifier and Type
Method
Description
`static Feature`
FeatureBuilder.`assemble(ArtifactId featureId, BuilderContext context, Feature... features)`
Assemble a feature based on the provided features.
`static Feature`
FeatureBuilder.`assemble(Feature feature, BuilderContext context)`
Assemble the full feature by processing its prototype.
`static Feature[]`
FeatureBuilder.`deduplicate(BuilderContext context, Feature... features)`
Remove duplicate and prototype features.
`void`
MergeHandler.`merge(HandlerContext context, Feature target, Feature source, Extension targetEx, Extension sourceEx)`
Merge the source extension into the target extension.
`void`
PostProcessHandler.`postProcess(HandlerContext context, Feature feature, Extension extension)`
Post process the feature with respect to the extension.
`static void`
FeatureBuilder.`resolveVariables(Feature feature, Map<String,String> additionalVariables)`
Resolve variables in the feature.

## Uses of Feature in org.apache.sling.feature.io.archive

Methods in org.apache.sling.feature.io.archive that return types with arguments of type Feature
Modifier and Type
Method
Description
`static Set<Feature>`
ArchiveReader.`read(InputStream in, ArchiveReader.ArtifactConsumer consumer)`
Read a feature model archive.
Methods in org.apache.sling.feature.io.archive with parameters of type Feature
Modifier and Type
Method
Description
`static JarOutputStream`
ArchiveWriter.`write(OutputStream out, Manifest baseManifest, ArtifactProvider provider, Feature... features)`
Create a feature model archive.

## Uses of Feature in org.apache.sling.feature.io.json

Methods in org.apache.sling.feature.io.json that return Feature
Modifier and Type
Method
Description
`static Feature`
FeatureJSONReader.`read(Reader reader, String location)`
Read a new feature from the reader The reader is not closed.
Methods in org.apache.sling.feature.io.json with parameters of type Feature
Modifier and Type
Method
Description
`static void`
FeatureJSONWriter.`write(Writer writer, Feature feature)`
Writes the feature to the writer.

## Uses of Feature in org.apache.sling.feature.osgi

Methods in org.apache.sling.feature.osgi that return Feature
Modifier and Type
Method
Description
`static Feature`
Converters.`convert(org.osgi.service.feature.Feature feature)`
Convert an OSGi feature into an Apache Sling feature
Methods in org.apache.sling.feature.osgi with parameters of type Feature
Modifier and Type
Method
Description
`static org.osgi.service.feature.Feature`
Converters.`convert(Feature feature)`
Convert an Apache Sling feature into an OSGi feature